<?

#
# ss.php					Author: Rich West
#						Rich.West@wesmo.com
#
# This is a not-all-that-complicated-but-not-all-that-simple perl script
# which takes the information from the database, jumbles it all up, and
# adds new entries to the database.  Basically, it does all of the picking
# of who-gets-who, while keeping in mind that there can be several different
# "groupings" of people (aka: multiple non-related secret santa picks could
# be handled by this same server) as well as certain restrictions on picks
# (people probably shouldn't (1) pick their spouse, (2) pick the same person
# they had last year, etc).
#
################################################################################

include "conf.php";
include "core_functions.php";

################################################################################
#
# Pull all of the names out of the database.
#
################################################################################
function get_people($connect,$gid)
{
   $i = 0;
   $query = "SELECT uid FROM accounts WHERE gid='$gid'";
   $result = mysql_query($query,$connect);
   while ($row = mysql_fetch_row($result))
   {
      $people[$i] = $row[0];
      $i++;
   }
   return($people);
}

################################################################################
#
# Pull all of the matches from the database that are considered "invalid".
#
################################################################################
function get_bad_matches($connect,$gid)
{
   $i=0;
   $query = "SELECT uid1,uid2 FROM invalids WHERE gid='$gid'";
   $result = mysql_query($query,$connect);
   while ($row = mysql_fetch_row($result))
   {
      $INVALIDS[$i][0] = $row[0];
      $INVALIDS[$i][1] = $row[1];
      $i++;
   }
   return ($INVALIDS);
}

################################################################################
#
# Randomly pick a person.
#
################################################################################
function get_randomness($PEOPLE)
{
   $random_choice = rand(0,sizeof($PEOPLE)-1);
   return ($random_choice);
}

################################################################################
#
# Associate a human readable name to the numeric picked.
#
################################################################################
function person_name($connect, $uid, $gid)
{
   $query = "SELECT name FROM accounts WHERE gid='$gid' AND uid='$uid'";
   $result = mysql_query($query,$connect);
   list($name) = mysql_fetch_row($result);
   return($name);
}

################################################################################
#
# Eliminate all of the bad matches.
#
################################################################################
function get_available($current_id,$PEOPLE,$invalids)
{
   for ($j=0; $j<=sizeof($invalids)-1; $j++)
   {
      if ($invalids[$j][0] == $current_id)
      {
#         print "Eliminating " . $invalids[$j][1] . "\n";
         $PEOPLE = array_minus_array(array_diff($PEOPLE, array($invalids[$j][1])));
      }
      if ($invalids[$j][1] == $current_id)
      {
#         print "Eliminating " . $invalids[$j][0] . "\n";
         $PEOPLE = array_minus_array(array_diff($PEOPLE, array($invalids[$j][0])));
      }
   }
   return ($PEOPLE);
}

################################################################################
#
# Clears out all of the old "picks"
#
################################################################################
function clear_picks($connect,$gid)
{
   $query = "DELETE FROM picks WHERE id='$gid'";
   $result = mysql_query($query,$connect);
}

function get_pick($i,$PEOPLE)
{
   $randomness = get_randomness($PEOPLE);
   $try=1;
   while ( ($PEOPLE[$randomness] == $i) and ($try <= 50))
   {
      $try++;
      $randomness = get_randomness($PEOPLE);
   }
   if ($try > 5)
   {
      print "Could not come up with a good selection.\n";
      exit;
   }
   print $i . "'s pick is: $PEOPLE[$randomness]<BR>\n";
   return ($PEOPLE[$randomness]);
}

function array_minus_array($a,$b)
{
   $c = Array();
   foreach ($a as $key => $val)
   {  
      $posb = array_search($val,$b);
      if (is_integer($posb))
      {
         unset($b[$posb]);  
      }
      else
      {
         $c[] = $val;
      }
   }
   return $c;
}

function save_picks($gid,$total_people,$picks)
{
   $expire_date = date("Y");
   $expire_date++;
   $expire_date = "$expire_date-11-01";
   for ($i=0; $i<=sizeof($total_people)-1; $i++)
   {
      $query = "INSERT INTO picks VALUES ('$gid', '$pick[$i][0]', '$pick[$i][1]', '$expire_date')";
      $result = mysql_query($query,$connect);
   }
}

################################################################################
#
# The main brains of the program.
#
################################################################################
   $connect = connectdb($db);
   //clear_picks($gid);
   $PEOPLE = get_people($connect, $gid);
   $invalids = get_bad_matches($connect,$gid);
   $ORIG_PEOPLE = $PEOPLE;
   $not_done = 1;
   $attempt = 0;
   $failed = 0;
   while ($not_done)
   {
      for ($i=0; $i<=sizeof($ORIG_PEOPLE)-1; $i++)
      {
echo "Working on $ORIG_PEOPLE[$i]..<BR>";
         $AVAIL = get_available($ORIG_PEOPLE[$i], $PEOPLE,$invalids);
         //delete $AVAIL{$temp};
         if (sizeof($AVAIL) == 0)
         {
            $attempt++;
            if ($attempt > 50)
            {
               $not_done = 0;
               $failed=1;
               echo "Could not come up with a good selection.\n";
            }
            $PEOPLE = $ORIG_PEOPLE;
            last;
         }
         $my_pick = get_pick($ORIG_PEOPLE[$i],$AVAIL);
         $PEOPLE = array_minus_array($PEOPLE, array($my_pick));
         $pick[$i][0] = $ORIG_PEOPLE[$i];
         $pick[$i][1] = $my_pick;
      }
      if (!$attempt) { $not_done = 0; }
   }
   if ($failed) { exit; }
#   save_picks($ID, sizeof($ORIG_PEOPLE),$picks);
echo "Picks:<BR>";
for ($k=0; $k<=sizeof($pick)-1; $k++) { echo $pick[$k][0] . " picked " . $pick[$k][1] . "<BR>"; }
?>
